;
;	Kpnz program VT-DOS-ra s UPM-re
;
;
;


	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	sp,07FF0h		; sajt veremterlet kialaktsa U1 tetejn
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a		; felhasznli lapoz rtk bersa (UPM miatt)
	ld	de,0005Ch		; DE az els paramterben megadott fjlnv FCB-re mutat
	ld	c,00Fh			; funkcikd: fjl megnyitsa
	call	0005h			; VT-DOS hvsa
	cp	0FFh
	jr	z,exit			; ugrs, ha nem sikerlt megnyitnia
	ld	de,puffer		; DE a kpfjl betltsi cmre mutat
folv:	push	de
	ld	c,01Ah			; funkcikd: diszk tviteli cm belltsa
	call	0005h			; VT-DOS hvsa
	ld	de,0005Ch		; DE az FCB-re mutat
	ld	c,014h			; funkcikd: szekvencilis olvass
	call	0005h			; VT-DOS hvsa
	pop	de
	or	a
	jr	nz,kepre		; ugrs, ha vge a fjlnak
	ld	hl,00080h		; tviteli cm nvelse 128-al
	add	hl,de
	ex	de,hl
	ld	hl,06800h		; HL= fels memriahatr
	sbc	hl,de
	jr	nc,folv			; ismtls a maximlisan olvashat hosszig
;
kepre:	push	de			; olvass vgcme a verembe
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	pop	hl			; vgcm HL-be
	ld	de,puffer		; DE a kpfjl betltsi cmre mutat
	or	a
	sbc	hl,de			; HL= olvasott hossz
	ex	de,hl			; DE s HL felcserlse
	call	kirajz			; kp kirajzolsa
var:	ld	e,0FFh
	ld	c,006h			; vrakozs egy gomb lenyomsra (direkt konzol input)
	call	0005h			; VT-DOS hvsa
	or	a
	jr	z,var
	ld	c,000h			; 2-szn md belltsa
	call	kepmod
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
;
exit:	jp	0000h			; vissza a VT-DOS-ba




;
;	VT-DOS konzol kurzor kikapcsolsa
;	in:  -
;	out: -
;
ed_dosoff:
	ld	de,curoff
	jr	ed_str


;
;	VT-DOS konzol kurzor bekapcsolsa
;	in:  -
;	out: -
;
ed_doson:
	ld	de,curon
ed_str:	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ret


;
;	ESC szekvencik a kurzor be/ki kapcsolshoz
;

curoff:	.db	012h			; kurzor kikapcsolsa UPM-en
	.db	01Bh,"x5"		; kurzor kikapcsolsa VT-DOS-on
	.db	00Ch			; kperny trlse (HOME UPM-en)
	.db	'$'			; stringet zr '$' karakter

curon:	.db	011h			; kurzor bekapcsolsa UPM-en
	.db	01Bh,"y5"		; kurzor bekapcsolsa VT-DOS-on
	.db	01Fh			; kperny trlse UPM-en
	.db	00Ch			; kperny trlse (HOME UPM-en)
	.db	'$'			; stringet zr '$' karakter


;
;	Kls modulokbl beillesztend programrszek
;

;
	#include "keplib.asm"
;



freemem	.equ	$			; az els szabad memricm a programkd utn

puffer	.equ	freemem


.end

